package liber

import (
	"fmt"
	"io"
)

func (db *Database) Refine(dir string) error {
	//storage := NewFileStorage(dir)
	return db.onAllBooks(func(book *Book) error {
		return nil
	})
}

// ListBooks writes IDs of books that match any of a series of
// functions to an io.Writer.
func (db *Database) ListBooks(w io.Writer, matchFuncs ...func(book *Book) bool) error {
	return db.onAllBooks(func(book *Book) error {
		ok := false
		for _, f := range matchFuncs {
			if f(book) {
				ok = true
				break
			}
		}
		if ok {
			fmt.Fprintf(w, "%s\n", book.Id)
		}
		return nil
	})
}
